/* Modulo: Color.c
 *
 * Curso: Computao Grfica - 2000
 * Ultima alterao: 20/03/2000
 *
 * Obs.: Esta classe  usada no programa para armazenar cor, tambm, no sistema YCrCb. Onde
 * Y equivale a R, Cr a G, Cb a B
 */

#ifndef COLOR_H
#define COLOR_H 

#include <stdio.h>

typedef struct _color {
  unsigned char r,g,b;//estas variveis so vistas pela Imagem
} Color;

Color  corCreate(unsigned char red, unsigned char green, unsigned char blue);
Color  corRead(FILE *fp);
Color  corCopy(Color c1);
Color  corAdd(Color c1, Color c2);
Color  corScale(double s, Color c);
Color  corReflect(double s, Color light, Color k);
double  corSqrMinus(Color c1, Color c2);
double  corMinus(Color c1, Color c2);
#endif
