/*=========================================================================*\
* Hash table implementation
* Diego Nehab
* 21/9/1999
\*=========================================================================*/

#ifndef _HASHTYPES_H_
#define _HASHTYPES_H_

/*=========================================================================*\
* Exported types and constants
\*=========================================================================*/
/* hash table element structure */
typedef struct t_hashnode {
	char *ident;				/* name of entry */
	long int order;			/* sequential number of element */
	long int num;	         /* number of color occurences */
} t_hashnode;
typedef t_hashnode *p_hashnode;

/* hash table structure */
typedef struct t_hash {
	p_hashnode table;			/* table of elements */
	long int *index;			/* table[index[element.order]] = element */
	long int size;			 	/* maximum number of entries in table */
	long int used;				/* number of used entries */
	int step;					/* step in geometrical growth */
} t_hash;
typedef struct t_hash *p_hash;

/* table iteration callback function */
typedef int (*p_hashcallback) (const char *ident, long int order, long int num);

#endif /* _HASHTYPES_H_ */
