/* test.c */

#include <stdio.h>
#include <time.h>

#include "render.h"

#define SZ_ARG     "uso: %s FILE.RT2 FILE.PPM\n"
#define SZ_ERR_CEN "Impossivel criar cenario!\n"
#define SZ_TEMPO   "levou %lf segundos\n" 


int main( int    argc , 
          char** argv  ) {
	
   Scene*  pCenario ;  /* cenrio */
   Image*  pImagem  ;  /* imagem */
   double  dTempo   ;  /* tempo que leva a renderizao */
   clock_t TempoIni ,  /* instante inicial */
           TempoFim ;  /* instante final */

/* testa se o formato da linha de comando est correto */
   if ( argc != 3 ) {
	   printf( SZ_ARG, argv[ 0 ] ) ;
		return 1 ;
	} /* if */

/* pega cenrio do arquivo de entrada e verifica se foi possvel cri-lo */
	pCenario = sceRead( argv[ 1 ] ) ;
   if ( pCenario == NULL ) {
      printf( SZ_ERR_CEN ) ;
      return 1 ;
   } /* if */ 
   
   TempoIni = clock( ) ; /* acha instante inicial */
   
/* a imagem  o resultado da renderizao do cenrio dado, se no foi 
   possvel criar a imagem, o programa ir ser abortado antes de retornar 
   de Render */
   pImagem = Render( pCenario ) ;

   TempoFim = clock( ) ; /* acha instante final */

   dTempo = ( TempoFim - TempoIni ) / CLK_TCK ; /* acha tempo de durao */

	imgWritePPM( pImagem, argv[ 2 ] ) ; /* grava a imagem no arquivo */
   sceDestroy( pCenario ) ;            /* desloca o cenrio */

   printf( SZ_TEMPO, dTempo ) ; /* imprime tempo para a renderizao */
   getchar( ) ; 

	return 0 ;
} 

/* test.c */