/** MODIFICADO POR JULIANA **/

/* Declaracoes do modulo ALGEBRA
 *
 * Curso: Computacao Grafica - 2000
 * Ultima alteracao: 26/02/2000
 *
*/
#ifndef ALGEBRA_H
#define ALGEBRA_H 1

#include <math.h>
#include <stdio.h>

typedef struct _v3d {
  double x;
  double y;
  double z;
} Vector3D;

Vector3D v3dCreate(double x, double y, double z);
Vector3D v3dCopy(Vector3D v);
Vector3D v3dMinus(Vector3D v);
Vector3D v3dAdd(Vector3D v1, Vector3D v2);
Vector3D v3dSub(Vector3D v1, Vector3D v2);
Vector3D v3dScale(double s, Vector3D v2);
Vector3D v3dVaLinComb(int n, ...);

double   v3dDot(Vector3D u, Vector3D v);
Vector3D v3dProj(Vector3D u, Vector3D v);
Vector3D v3dLinearInterpol(Vector3D v1, Vector3D v2, double t);
double   v3dNorm(Vector3D v);
Vector3D v3dNormalize(Vector3D v);
Vector3D v3dCross(Vector3D u, Vector3D v);

int      v3dWrite(Vector3D v, FILE *file);
Vector3D v3dRead(FILE *file);


/*==============================================================================
*Nome: Refletir
*Descrio da Funo: funo que reflete um raio em torno do vetor normal de uma
*                     superfcie.
*
*Parametros recebidos
*   Raio:   o raio;
*   Normal: a normal da superfcie.
*
*Valor Retornado
*   o raio refletido.
*=============================================================================*/

Vector3D Refletir( Vector3D Raio  ,
                   Vector3D Normal ) ;


#if 0

Vector3D    t3dApply(Transform3D t, Vector3D v);
Transform3D t3dCompose(Transform3D T1, Tansform3D T2);
Transform3D t3dCreate(double m[12]);

Transform3D t3dScale(double sx, double sy, double sz);
Transform3D t3dTranslate(double tx, double ty, double tz);
Transform3D t3dRotate(double alpha, Vector3D v);
Transform3D t3dIdentity(void);

/* int         t3dWrite(Transform3D T, FILE *file); */
Transform3D t3dRead(FILE *file);

#endif

#endif












