/** MODIFICADO POR JULIANA **/

/* Interface do mdulo CAMERA 
 *
 * Curso: Computacao Grafica - 2000
 * ultima revisao: 27/02/2000
 */


#ifndef CAMERA_H
#define CAMERA_H

#include <stdio.h>

#include "raytrace.h"


/* pre-declaracao do tipo sem dar informacoes sobre o conteudo */
struct Camera_impl;
typedef struct Camera_impl Camera;

Camera *camCreate(Vector3D eyel, Vector3D atl, Vector3D upl,
                  double fovyl, double nearpl, double farpl, 
                  int screen_wl, int screen_hl);

Camera *camRead(FILE *fp);   /* cria uma camera a partir dos dados no arquivo fp */

Ray camRay(Camera *cam, double x, double y); /* retorna o raio correspondente ao pixel (i,j) */

int camScreenW(Camera *cam);  /* retorna o numero de colunas da imagem da camera */

int camScreenH(Camera *cam);  /* retorna o numero de colunas da imagem da camera */

void camDestroy(Camera *cam); /* destroi uma camera */


/*==============================================================================
*Nome: PegarOlhoCam
*Descrio da Funo: funo que devolve o olho de uma dada cmera.
*
*Parametro recebido
*   pCam: a cmera.
*
*Valor Retornado
*   as coordenadas do olho.
*=============================================================================*/

Vector3D PegarOlhoCam( Camera* pCam ) ;


#endif


