/** MODIFICADO POR JULIANA **/

/* Modulo: Color.c
 *
 * Curso: Computao Grfica - 2000
 * Ultima alterao: 27/02/2000
 */
#include <stdio.h>
#include "color.h"

static double Clamp(double val) {
  if ( val<0.0 ) 
    return 0.0;
  else if ( val>1.0 ) 
    return 1.0;
  else
    return val;
}

Color  corCreate(double red, double green, double blue) {
  Color c;
  c.r = Clamp(red);
  c.g = Clamp(green);
  c.b = Clamp(blue);
  return c;
}

Color  corRead(FILE *fp)
{
	double red=0.0, green=0.0, blue=0.0;
	
	if (fscanf(fp, "%lf %lf %lf", &red, &green, &blue) != 3) {
		printf("[%s:%d] error reading color components (%g, %g, %g)\n",
		       __FILE__, __LINE__, red, green, blue);
	}

	return corCreate(red/255.0, green/255.0, blue/255.0);
}
 
Color  corCopy(Color c1) {
  Color c;
  c.r = c1.r;
  c.g = c1.g;
  c.b = c1.b;
  return c;
}


Color  corAdd(Color c1, Color c2) {
  Color c;
  c.r = Clamp(c1.r+c2.r);
  c.g = Clamp(c1.g+c2.g);
  c.b = Clamp(c1.b+c2.b);
  return c;
}

Color  corScale(double s, Color c1) {
  Color c;
  c.r = Clamp(s*c1.r);
  c.g = Clamp(s*c1.g);
  c.b = Clamp(s*c1.b);
  return c;
}

Color  corReflect(double s, Color light, Color k) {
  Color c;
  c.r = Clamp(s*(light.r*k.r));
  c.g = Clamp(s*(light.g*k.g));
  c.b = Clamp(s*(light.b*k.b));
  return c;
}


/*==============================================================================
*Nome: dPegarVerm
*=============================================================================*/

double dPegarVerm( Color Cor ) {
   return Cor.r ;
} /* dPegarVerm */


/*==============================================================================
*Nome: dPegarVerde
*=============================================================================*/

double dPegarVerde( Color Cor ) {
   return Cor.g ;
} /* dPegarVerde */


/*==============================================================================
*Nome: dPegarAzul
*=============================================================================*/

double dPegarAzul( Color Cor ) {
   return Cor.b ;
} /* dPegarAzul */
