/** MODIFICADO POR JULIANA **/

#include <assert.h>
#include <string.h>
#include "material.h"

Material matRead( FILE *fp )
{
	Material mat;
	char imgname[1024];

	mat.ambient = corRead( fp );
	mat.diffuse = corRead( fp );
	mat.specular = corRead( fp );

	strcpy( imgname, "null" );
	fscanf( fp, "%lf %lf %lf %lf %s", &(mat.n), &(mat.reflect), &(mat.refract),
	        &(mat.opacity), imgname );

#ifndef NDEBUG
	printf("\n[%s:%d] read material:\n", __FILE__, __LINE__);
	
	printf("\tambient = (%g, %g, %g)\n",
	       mat.ambient.r, mat.ambient.g, mat.ambient.b);
	printf("\tdiffuse = (%g, %g, %g)\n",
	       mat.diffuse.r, mat.diffuse.g, mat.diffuse.b);
	printf("\tspecular = (%g, %g, %g),\n",
	       mat.specular.r, mat.specular.g, mat.specular.b);
	printf("\ttexture = '%s',\n", imgname);
	printf("\tn = %g,\n", mat.n);
	printf("\treflect = %g,\n", mat.reflect);
	printf("\trefract = %g,\n", mat.refract);
	printf("\topacity = %g\n", mat.opacity);
#endif

	if (strcmp( imgname, "null" ) == 0) {
		mat.img = NULL;
		return mat;
	}

	mat.img = imgReadPPM( imgname );
	return mat;
}


/*==============================================================================
*Nome: PegarImg
*=============================================================================*/

Image* PegarImg( Material ObjMat ) { 
   return ObjMat.img ;
} /* PegarImg */


/*==============================================================================
*Nome: PegarAmb
*=============================================================================*/

Color PegarAmb( Material ObjMat ) {
   return ObjMat.ambient ;
} /* PegarAmb */


/*==============================================================================
*Nome: PegarDif
*=============================================================================*/

Color PegarDif( Material ObjMat ) {
   return ObjMat.diffuse ;
} /* PegarDif */


/*==============================================================================
*Nome: PegarEsp
*=============================================================================*/

Color PegarEsp( Material ObjMat ) {
   return ObjMat.specular ;
} /* PegarEsp */


/*==============================================================================
*Nome: dPegarNCoss
*=============================================================================*/

double dPegarNCoss( Material ObjMat ) {
   return ObjMat.n ;
} /* dPegarNCoss */


/*==============================================================================
*Nome: dPegarNRefle
*=============================================================================*/

double dPegarNRefle( Material ObjMat ) {
   return ObjMat.reflect ;
} /* dPegarNRefle */


/*==============================================================================
*Nome: dPegarNRefra
*=============================================================================*/

double dPegarNRefra( Material ObjMat ) {
   return ObjMat.refract ;
} /* dPegarNRefra */


/*==============================================================================
*Nome: dPegarOpac
*=============================================================================*/

double dPegarOpac( Material ObjMat ) {
   return ObjMat.opacity ;
} /* dPegarOpac */